# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.BigQueryDataTransfer.V1.Model.EmailPreferences do
  @moduledoc """
  Represents preferences for sending email notifications for transfer run events.

  ## Attributes

  *   `enableFailureEmail` (*type:* `boolean()`, *default:* `nil`) - If true, email notifications will be sent on transfer run failures.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :enableFailureEmail => boolean() | nil
        }

  field(:enableFailureEmail)
end

defimpl Poison.Decoder, for: GoogleApi.BigQueryDataTransfer.V1.Model.EmailPreferences do
  def decode(value, options) do
    GoogleApi.BigQueryDataTransfer.V1.Model.EmailPreferences.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.BigQueryDataTransfer.V1.Model.EmailPreferences do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
